extern "C"
{
#include "capi.h"
}

#include "logdb.h" 

void logdb_allocate(LOGDB_CTX* ctx, LONGINT total_data, INT data_size, INT data_per_block)
{
    ctx->db = new LogDB(total_data, data_size, data_per_block);
}

void logdb_free(LOGDB_CTX* ctx)
{
    delete (LogDB*)ctx->db;
}

void logdb_init(LOGDB_CTX* ctx, const char* db_file_name, const char* ix_file_name, GET_DATA_F get_data, int cache_entries)
{
    ((LogDB*)ctx->db)->Init(db_file_name, ix_file_name, get_data, cache_entries);
}

void logdb_open(LOGDB_CTX* ctx, const char* db_file_name, const char* ix_file_name, int cache_entries)
{
    ((LogDB*)ctx->db)->Open(db_file_name, ix_file_name, cache_entries);
}

LONGINT logdb_size(LOGDB_CTX* ctx)
{
    return ((LogDB*)ctx->db)->Size();
}

void logdb_read(LOGDB_CTX* ctx, LONGINT elm, void* res)
{
    ((LogDB*)ctx->db)->Read(elm, res);
}

void logdb_read_historic(LOGDB_CTX* ctx, LONGINT elm, void* res, time_t t)
{
    ((LogDB*)ctx->db)->Read(elm, res, t);
}

void logdb_update(LOGDB_CTX* ctx, LONGINT elm, void* res)
{
    ((LogDB*)ctx->db)->Update(elm, res);
}

void logdb_batch_update_begin(LOGDB_CTX* ctx)
{
    ((LogDB*)ctx->db)->BatchUpdateBegin();
}

void logdb_batch_update(LOGDB_CTX* ctx, LONGINT elm, void* res)
{
    ((LogDB*)ctx->db)->BatchUpdate(elm, res);
}

void logdb_batch_update_commit(LOGDB_CTX* ctx)
{
    ((LogDB*)ctx->db)->BatchUpdateCommit();
}
