#ifndef CAPI_H
#define CAPI_H

#include <time.h>

#include "common.h"

struct LOGDB_CTX
{
    void *db;
};

typedef struct LOGDB_CTX LOGDB_CTX;

void logdb_allocate(LOGDB_CTX* ctx, LONGINT total_data, INT data_size, INT data_per_block);
void logdb_free(LOGDB_CTX* ctx);
void logdb_init(LOGDB_CTX* ctx, const char* db_file_name, const char* ix_file_name, GET_DATA_F get_data, int cache_entries);
void logdb_open(LOGDB_CTX* ctx, const char* db_file_name, const char* ix_file_name, int cache_entries);
LONGINT logdb_size(LOGDB_CTX* ctx);
void logdb_read(LOGDB_CTX* ctx, LONGINT elm, void* res);
void logdb_read_historic(LOGDB_CTX* ctx, LONGINT elm, void* res, time_t t);
void logdb_update(LOGDB_CTX* ctx, LONGINT elm, void* res);
void logdb_batch_update_begin(LOGDB_CTX* ctx);
void logdb_batch_update(LOGDB_CTX* ctx, LONGINT elm, void* res);
void logdb_batch_update_commit(LOGDB_CTX* ctx);

#endif
