#ifndef LOGDBFILE_H
#define LOGDBFILE_H

#include <vector>

#include <cstdio>
#include <ctime>

using namespace std;

#include "common.h"
#include "cache.h"

const time_t NOW = 0;

// root at given time
// used by LogDBFile class
struct TS
{
    time_t t;
    LONGINT root;
};

// low level read and write
// used by LogDB class
class LogDBFile
{
private:
    FILE* fp;
    INT block_size;
    LONGINT write_ptr;
    char ixfnm[256];
    vector<TS> ts;
    TS last;
    ReadCache* cache;
    void LoadTS();
public:
    LogDBFile(const char* db_file_name, const char* ix_file_name, const char* mode, INT block_size, int cache_entries = 0);
    virtual ~LogDBFile();
    void Write(void* buf);
    void Write(void* buf, int noblocks);
    void Read(LONGINT ptr, void* buf);
    void Mark();
    LONGINT GetRoot();
    LONGINT GetRoot(time_t t);
    LONGINT GetLastWritePtr();
};

#endif